do

	local oldModBlueprints = ModBlueprints
	function ModBlueprints(all_bps)
		oldModBlueprints(all_bps)

		local	r, v	=	2.0, 3.0	--	range, and velocity multipliers.
		local	e, bias	=	2.0, 1.5	--	RoF exponent, and artificial average adjustment.
		--	current values allow ACUs to 1-shot T1 Eng.

		for	id, bp in all_bps.Unit do

			if bp.Economy and bp.Economy.MaxBuildDistance then
				bp.Economy.MaxBuildDistance	=	bp.Economy.MaxBuildDistance	* r
			end
		
			if bp.Enhancements then
				
				for ik, enh in bp.Enhancements do

					if enh.NewMaxRadius then
						enh.NewMaxRadius = enh.NewMaxRadius * r
					end
					
					--	UEF ACU's Zephyr.
					if enh.ZephyrDamageMod then
						enh.ZephyrDamageMod = enh.ZephyrDamageMod * math.pow(bias, e - 1)
					end

					--	Seraphim ACU's Refractor.
					if enh.AdditionalDamage then
						enh.AdditionalDamage = enh.AdditionalDamage * math.pow(bias, e - 1)
					end
					
				end
				
			end
		
			if bp.Intel then
				bp.Intel.VisionRadius	= 	math.floor((bp.Intel.VisionRadius or 0) * r)
				bp.Intel.UnderWaterVisionRadius = math.floor((bp.Intel.UnderWaterVisionRadius or 0) * r)
				bp.Intel.RadarRadius	= 	math.floor((bp.Intel.RadarRadius or 0) * r)
				bp.Intel.SonarRadius	= 	math.floor((bp.Intel.SonarRadius or 0) * r)
				bp.Intel.OmniRadius		= 	math.floor((bp.Intel.OmniRadius or 0) * r)
			end

			if bp.Weapon then

				for ik, wep in bp.Weapon do

					if wep.MuzzleVelocity then
					
						wep.MuzzleVelocity = wep.MuzzleVelocity * math.sqrt(r)
											
						if wep.BallisticArc == 'RULEUBA_None' then
							wep.MuzzleVelocity = wep.MuzzleVelocity * v
						else
							if not (wep.WeaponCategory == 'Artillery') then

								wep.MuzzleVelocity = wep.MuzzleVelocity * v

							else
--								wep.MuzzleVelocity = wep.MuzzleVelocity * math.sqrt(v)

								if wep.MuzzleVelocityReduceDistance then
									wep.MuzzleVelocityReduceDistance = wep.MuzzleVelocityReduceDistance / v
								end
							
								--	re-calculate (or calculate) minimum range.
								--		y	=	y't	+	1/2*y"t^2
								--	but, since y = 0, and y" < 0;
								--		y't	=	1/2	*	y"t^2
								--		y'	=	1/2	*	y"t
								--	:.	t	=	2	*	y'/y"
								
								--	the equation goes;
								--	m = 0.5 * v^2 * sin(2.theta) / g	--	it does not!
								--	but, we need to convert to radians.
								--	so the constant term simplifies to pi / 90.
								--	finally, the 
								local p = (wep.TurretPitch or 0) + ((wep.TurretPitchRange or 0) / 2)
								local m = math.pow(wep.MuzzleVelocity, 2) * math.sin(math.pi / 90 * p) / 9.8
								if m > (wep.MinRadius or 0) then
									LOG('*BM: ' .. bp.BlueprintId .. ' ' .. wep.MinRadius .. ' ' .. m)
									wep.MinRadius = m
								end
							end
							
							wep.ProjectileLifeTime = nil --	1.5 * wep.MuzzleVelocity / 4.9	--	sqrt(2) * ||velocity|| / ||a||
						end
	
					end

					if wep.MaxRadius and not (wep.RangeCategory == 'UWRC_Countermeasure') and not (bp.General.Category == 'Gunship') then
						wep.MaxRadius = math.floor(wep.MaxRadius * r)
					end
				
					if wep.MinRadius and (bp.General.Category != 'Gunship') then
						wep.MinRadius = wep.MinRadius * r
					end
					
					if wep.ProjectileLifetime then
						wep.ProjectileLifetime = wep.ProjectileLifetime * r
					end
					
					if wep.RateOfFire and not wep.ManualFire and not (wep.WeaponCategory == 'Bomb') then

						gain = math.pow(wep.RateOfFire / bias, e - 1)

						if gain * wep.RateOfFire < 0.05 then	--	check for stupidly low RoF; such as a Lobo's 1-shot every 100 seconds.
							gain = 0.05 / wep.RateOfFire
						end
						
						if gain * wep.RateOfFire > 10 then		--	check for RoFs higher than the engine's limit of 10Hz calculation rate.
							gain = 10 / wep.RateOfFire
						end
						
						if wep.MuzzleSalvoDelay then
							wep.MuzzleSalvoDelay = wep.MuzzleSalvoDelay * gain
						end
						
						if wep.RackSalvoChargeTime then
							wep.RackSalvoChargeTime = wep.RackSalvoChargeTime / gain
						end
						
						wep.RateOfFire = wep.RateOfFire * gain
						wep.Damage = wep.Damage / gain
						
						if gain > 1 then
							if wep.FiringRandomness then
								wep.FiringRandomness = wep.FiringRandomness * gain
							else
								wep.FiringRandomness = 0.01
							end
						end
						
					end

				end	--	bp.Weapon loop

			end
		
			if bp.Wreckage and bp.Wreckage.HealthMult then
				bp.Wreckage.HealthMult	=	10
			end
			
		end	--	all_bps.Unit loop
		
		for id, em in all_bps.Emitter do
		
			if em.EmitRateCurve and em.EmitRateCurve.Keys then

				for ik, key in em.EmitRateCurve.Keys do
				
					if key.x then
						key.x = key.x * v
					end
					if key.y then
						key.y = key.y * v
					end
					if key.Z then
						key.z = key.z * v
					end
				
				end

				for ik, key in em.LifetimeCurve.Keys do
				
					if key.x then
						key.x = key.x / v
					end
					if key.y then
						key.y = key.y / v
					end
					if key.z then
						key.z = key.z / v
					end
				
				end
				
			end
		
		end	--	all_bps.Emitter loop
		
	end	--	ModBlueprints

end